/* ^C}[̃Tv */
/* cc -lrt -o timer timer.c (Linux) */
#include<stdio.h>
#include<time.h>
#include<signal.h>

void
handler(int	signum)
{
	printf("signum = %d\n",signum);
}

int
main(void)
{
	int	i;
	timer_t	timerId;
	struct itimerspec	itval;
	struct sigaction	sigact;

	itval.it_interval.tv_sec = 2;			/*	^C}[ibjݒ		*/
	itval.it_interval.tv_nsec = 0;			/*	^C}[iimbjݒ	*/
	itval.it_value.tv_sec = 2;				/*	^C}[ԁibjݒ		*/
	itval.it_value.tv_nsec = 0;				/*	^C}[ԁiimbjݒ	*/

	sigact.sa_handler = handler;
	sigact.sa_flags = 0;
	sigemptyset(&sigact.sa_mask);

											/*	nhݒ				*/
	if(sigaction(SIGALRM,&sigact,NULL) == -1)
	{
		perror("sigaction");
	}

											/*	^C}[쐬				*/
	if(timer_create(CLOCK_REALTIME,NULL,&timerId) == -1)
	{
		perror("timer_create");
	}
											/*	^C}[ݒ				*/
	if(timer_settime(timerId,0,&itval,NULL) == -1)
	{
		perror("timer_settime");
	}

	for(i = 0;i < 5;i++)
	{
		pause(0);							/*	VOi҂				*/
	}
											/*	^C}[폜				*/
	if(timer_delete(timerId) == -1)
	{
		perror("timer_delete");
	}

	return 0;
}
